#ifndef stack_h
#define stack_h

#include "context.h"

typedef struct ContextStack ContextStack;

struct ContextStack {
    ContextStack *next;
    Context x;
};

extern ContextStack *bottom;

extern void ContextStack_init(void);
extern ContextStack *ContextStack_push(ContextStack *top, TagTypes tag);

extern ContextStack *ContextStack_mark(void);
extern ContextStack *ContextStack_gc(ContextStack *mark, ContextStack *top);

extern void ContextStack_dump(char *message, int lookahead,
    ContextStack *top);

#endif
